function labels = run_logistic_regression(offset, weights, features)
    
    weight_sums = repmat(offset, size(features, 1), 1) + ...
        sum(repmat(weights, size(features, 1), 1) .* features, 2);
    
    positive_indices = find(weight_sums > 0);
    labels = zeros(size(weight_sums, 1), 1);
    labels(positive_indices) = 1;